MYREFERER = [
    "mithrandr.moria.org",
    "mithrandir.moria.org",
    "nbm.rucus.net",
    "196.25.137.64",
    "196.7.14.18",
]

REFERERSPAMMERS = [
    "massivecocks.com",
    "kwmap.com",
    "akksess.com",
    "bongohome.com",
    "wr18.com",
    "malixya.com",
    "4freelivexcams.com",
    "cria.ca",
    'paris-hilton-video.blogspot.com',
    'visitcelebrities.com',
    'vanillaice.net',
    'femalecelebrity.net',
    'cape-town-news.newslib.com',
    'blackjack.turtlemeat.com',
    'search4hardcore.com',
    'hotelhieress.com',
    'bobbakazoo.com',
    'my-fetishes.com',
    'freenudecelebrity.net',
    'nudecelebblogs.com',
    'britneyspearsnude.blogspot.com',
    'freewebcams.reallyconfused.com',
    'amateurxpass.com',
    'cpaadmin.globaltravel.com',
    'www.blingblangblog.com',
    'shatteredreality.net',
]

# IPs which should be excluded from all processing
EXCLUDEIPS = [
    "196.7.14.18",
    "209.237.228.186",
    "211.99.203.195",
    "211.99.203.197",
    "207.31.251.130",
    "203.236.43.75",
    "193.11.248.152",
    "24.173.210.90",
    "211.99.203.198",
    "141.85.3.130",
    "217.73.164.106",
    "211.99.213.18",
    "193.120.138.82",
    "151.205.112.49",
    "151.205.106.76",
    '62.45.205.145',
    '220.73.165.76',
    '202.101.124.146',
    '210.198.232.59',
    '219.137.8.243',
    '207.203.45.130',
]

# IP to name conversion
IP_TO_NAME = {
    "196.7.0.164": "UUNet cache",
    "146.231.128.4": "Rhodes",
    "146.231.128.8": "Rhodes",
    "137.158.128.105": "UCT",
    "137.158.128.106": "UCT",
    "137.158.128.107": "UCT",
    "196.11.235.1": "University of Western Cape",
    '198.54.202.2': 'Cape Town SAIX Cache',
    '155.238.8.16': 'Cape Technikon',
    '196.2.56.5': 'Cape Town MWeb Cache',
    '196.22.192.24': 'Storm cache',
    '196.21.193.22': 'petech',
}

# Searches to exclude from search processing
EXCLUDESEARCHES = [
    "fire daemon",
    "\"fire daemon",
    "fire+daemon",
    "\"fire daemon\"",
    "fire daemon\\",
    "ssh-1.99-openssh_3.5p1 freebsd-20021029",
    "ssh-1.99-openssh_3.5p1",
    "ssh-1.99-openssh_3.4p1",
    "ssh-1.99-openssh_3.4",
    "fire-daemon",
]

# "Header" for the HTML files
TEMPLATE_START = """
  <head>
    <title>%s</title>
    <link rel="stylesheet" href="/nbm.css" type="text/css">
    <link rel="stylesheet" href="/stats/referers.css" type="text/css">
  </head>
  <body>
    <div id="main">"""

# For EXCLUDEDBYFUNC, the locations you browser to the site from.
PLACES_I_VISIT = [
    "196.15.188.2",
    "196.14.181.9",
    "195.173.63.5",
    "196.30.168.70",
    "155.239.150.101",
    "155.239.146.230",
    "155.239.150.170",
    "155.239.147.155",
]

# For EXCLUDEDBYFUNC, the Agent strings for your browsers.
MY_AGENTS = [
    "Mozilla/5.0 (compatible; Konqueror/3.1; FreeBSD 5.0-RELEASE)",
    "Mozilla/5.0 (compatible; Konqueror/3.1; FreeBSD 5.1-RELEASE)",
    "Mozilla/5.0 (compatible; Konqueror/3.1; FreeBSD)",
]

HTMLEXCLUDEPATTERNS = [
    "/stats/",
]

HTMLPATTERNS = [
    ".html",
    "/ ",
]

DOWNLOADEXCLUDEPATTERNS = [
    ".doc",
]

DOWNLOADPATTERNS = [
    "/files/",
    "/dist/",
]

# EXCLUDEDBYFUNC is a way to exclude certain log entries from being
# processed, for example to prevent your own accesses from being
# recorded in the statistics.
def EXCLUDEDBYFUNC(line):
    if line['ip'] in PLACES_I_VISIT and line['agent'] in MY_AGENTS:
        return 1
    if line['ip'].startswith("155.239.") and line['agent'] in MY_AGENTS:
        return 1
    if line['agent'] == 'Mozilla/5.0 (compatible; Konqueror/3.1; FreeBSD 5.1-RELEASE; N)':
        return 1
    if line['agent'] == 'Mozilla/5.0 (compatible; Konqueror/3.1; Linux; N)':
        return 1
    if line['agent'] == 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.5a; N) Gecko/20030728 Mozilla Firebird/0.6.1':
        return 1
    if line['agent'] == 'MSIE 6.0':
        return 1
    if line['agent'] == 'Mozilla/4.0':
        return 1
    return 0
